/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-maggie-ir-controller-msgs-0.0.2-0quantal-20150414-0458/msg/GetTvAction.msg
 *
 */


#ifndef MAGGIE_IR_CONTROLLER_MSGS_MESSAGE_GETTVACTION_H
#define MAGGIE_IR_CONTROLLER_MSGS_MESSAGE_GETTVACTION_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace maggie_ir_controller_msgs
{
template <class ContainerAllocator>
struct GetTvAction_
{
  typedef GetTvAction_<ContainerAllocator> Type;

  GetTvAction_()
    : last_update()
    , action()  {
    }
  GetTvAction_(const ContainerAllocator& _alloc)
    : last_update()
    , action(_alloc)  {
    }



   typedef ros::Time _last_update_type;
  _last_update_type last_update;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _action_type;
  _action_type action;




  typedef boost::shared_ptr< ::maggie_ir_controller_msgs::GetTvAction_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::maggie_ir_controller_msgs::GetTvAction_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct GetTvAction_

typedef ::maggie_ir_controller_msgs::GetTvAction_<std::allocator<void> > GetTvAction;

typedef boost::shared_ptr< ::maggie_ir_controller_msgs::GetTvAction > GetTvActionPtr;
typedef boost::shared_ptr< ::maggie_ir_controller_msgs::GetTvAction const> GetTvActionConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::maggie_ir_controller_msgs::GetTvAction_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::maggie_ir_controller_msgs::GetTvAction_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace maggie_ir_controller_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'maggie_ir_controller_msgs': ['/tmp/buildd/ros-hydro-maggie-ir-controller-msgs-0.0.2-0quantal-20150414-0458/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::maggie_ir_controller_msgs::GetTvAction_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::maggie_ir_controller_msgs::GetTvAction_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::maggie_ir_controller_msgs::GetTvAction_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::maggie_ir_controller_msgs::GetTvAction_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::maggie_ir_controller_msgs::GetTvAction_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::maggie_ir_controller_msgs::GetTvAction_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::maggie_ir_controller_msgs::GetTvAction_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ca0575195a4eb06ecf7ab1e529755694";
  }

  static const char* value(const ::maggie_ir_controller_msgs::GetTvAction_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xca0575195a4eb06eULL;
  static const uint64_t static_value2 = 0xcf7ab1e529755694ULL;
};

template<class ContainerAllocator>
struct DataType< ::maggie_ir_controller_msgs::GetTvAction_<ContainerAllocator> >
{
  static const char* value()
  {
    return "maggie_ir_controller_msgs/GetTvAction";
  }

  static const char* value(const ::maggie_ir_controller_msgs::GetTvAction_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::maggie_ir_controller_msgs::GetTvAction_<ContainerAllocator> >
{
  static const char* value()
  {
    return "#\n\
# \n\
#\n\
\n\
time last_update\n\
string action\n\
";
  }

  static const char* value(const ::maggie_ir_controller_msgs::GetTvAction_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::maggie_ir_controller_msgs::GetTvAction_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.last_update);
      stream.next(m.action);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct GetTvAction_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::maggie_ir_controller_msgs::GetTvAction_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::maggie_ir_controller_msgs::GetTvAction_<ContainerAllocator>& v)
  {
    s << indent << "last_update: ";
    Printer<ros::Time>::stream(s, indent + "  ", v.last_update);
    s << indent << "action: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.action);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MAGGIE_IR_CONTROLLER_MSGS_MESSAGE_GETTVACTION_H
